Index: LMDZ6/branches/Amaury_dev/libf/phylmd/dyn1d/1DUTILS.h
===================================================================
--- LMDZ6/branches/Amaury_dev/libf/phylmd/dyn1d/1DUTILS.h	(revision 5102)
+++ LMDZ6/branches/Amaury_dev/libf/phylmd/dyn1d/1DUTILS.h	(revision 5103)
@@ -1494,435 +1478,433 @@
 !  Subroutines for nudging
 
-      Subroutine Nudge_RHT_init (paprs,pplay,t,q,t_targ,rh_targ)
-! ========================================================
+Subroutine Nudge_RHT_init (paprs, pplay, t, q, t_targ, rh_targ)
+  ! ========================================================
   USE dimphy
 
   implicit none
 
-! ========================================================
-      REAL paprs(klon,klevp1)
-      REAL pplay(klon,klev)
-
-!      Variables d'etat
-      REAL t(klon,klev)
-      REAL q(klon,klev)
-
-!   Profiles cible
-      REAL t_targ(klon,klev)
-      REAL rh_targ(klon,klev)
-
-   INTEGER k,i
-   REAL zx_qs
-
-! Declaration des constantes et des fonctions thermodynamiques
-
-include "YOMCST.h"
-include "YOETHF.h"
-
-!  ----------------------------------------
-!  Statement functions
-include "FCTTRE.h"
-!  ----------------------------------------
-
-        DO k = 1,klev
-         DO i = 1,klon
-           t_targ(i,k) = t(i,k)
-           IF (t(i,k).LT.RTT) THEN
-              zx_qs = qsats(t(i,k))/(pplay(i,k))
-           ELSE
-              zx_qs = qsatl(t(i,k))/(pplay(i,k))
-           ENDIF
-           rh_targ(i,k) = q(i,k)/zx_qs
-         ENDDO
-        ENDDO
-      print *, 't_targ',t_targ
-      print *, 'rh_targ',rh_targ
-
-
-      RETURN
-      END
-
-      Subroutine Nudge_UV_init (paprs,pplay,u,v,u_targ,v_targ)
-! ========================================================
+  ! ========================================================
+  REAL paprs(klon, klevp1)
+  REAL pplay(klon, klev)
+
+  !      Variables d'etat
+  REAL t(klon, klev)
+  REAL q(klon, klev)
+
+  !   Profiles cible
+  REAL t_targ(klon, klev)
+  REAL rh_targ(klon, klev)
+
+  INTEGER k, i
+  REAL zx_qs
+
+  ! Declaration des constantes et des fonctions thermodynamiques
+
+  include "YOMCST.h"
+  include "YOETHF.h"
+
+  !  ----------------------------------------
+  !  Statement functions
+  include "FCTTRE.h"
+  !  ----------------------------------------
+
+  DO k = 1, klev
+    DO i = 1, klon
+      t_targ(i, k) = t(i, k)
+      IF (t(i, k)<RTT) THEN
+        zx_qs = qsats(t(i, k)) / (pplay(i, k))
+      ELSE
+        zx_qs = qsatl(t(i, k)) / (pplay(i, k))
+      ENDIF
+      rh_targ(i, k) = q(i, k) / zx_qs
+    ENDDO
+  ENDDO
+  print *, 't_targ', t_targ
+  print *, 'rh_targ', rh_targ
+
+  RETURN
+END
+
+Subroutine Nudge_UV_init (paprs, pplay, u, v, u_targ, v_targ)
+  ! ========================================================
   USE dimphy
 
   implicit none
 
-! ========================================================
-      REAL paprs(klon,klevp1)
-      REAL pplay(klon,klev)
-
-!      Variables d'etat
-      REAL u(klon,klev)
-      REAL v(klon,klev)
-
-!   Profiles cible
-      REAL u_targ(klon,klev)
-      REAL v_targ(klon,klev)
-
-   INTEGER k,i
-
-        DO k = 1,klev
-         DO i = 1,klon
-           u_targ(i,k) = u(i,k)
-           v_targ(i,k) = v(i,k)
-         ENDDO
-        ENDDO
-      print *, 'u_targ',u_targ
-      print *, 'v_targ',v_targ
-
-
-      RETURN
-      END
-
-      Subroutine Nudge_RHT (dtime,paprs,pplay,t_targ,rh_targ,t,q,          &
-     &                      d_t,d_q)
-! ========================================================
+  ! ========================================================
+  REAL paprs(klon, klevp1)
+  REAL pplay(klon, klev)
+
+  !      Variables d'etat
+  REAL u(klon, klev)
+  REAL v(klon, klev)
+
+  !   Profiles cible
+  REAL u_targ(klon, klev)
+  REAL v_targ(klon, klev)
+
+  INTEGER k, i
+
+  DO k = 1, klev
+    DO i = 1, klon
+      u_targ(i, k) = u(i, k)
+      v_targ(i, k) = v(i, k)
+    ENDDO
+  ENDDO
+  print *, 'u_targ', u_targ
+  print *, 'v_targ', v_targ
+
+  RETURN
+END
+
+Subroutine Nudge_RHT (dtime, paprs, pplay, t_targ, rh_targ, t, q, &
+        &                      d_t, d_q)
+  ! ========================================================
   USE dimphy
 
   implicit none
 
-! ========================================================
-      REAL dtime
-      REAL paprs(klon,klevp1)
-      REAL pplay(klon,klev)
-
-!      Variables d'etat
-      REAL t(klon,klev)
-      REAL q(klon,klev)
-
-! Tendances
-      REAL d_t(klon,klev)
-      REAL d_q(klon,klev)
-
-!   Profiles cible
-      REAL t_targ(klon,klev)
-      REAL rh_targ(klon,klev)
-
-!   Temps de relaxation
-      REAL tau
-!c      DATA tau /3600./
-!!      DATA tau /5400./
-      DATA tau /1800./
-
-   INTEGER k,i
-   REAL zx_qs, rh, tnew, d_rh, rhnew
-
-! Declaration des constantes et des fonctions thermodynamiques
-
-include "YOMCST.h"
-include "YOETHF.h"
-
-!  ----------------------------------------
-!  Statement functions
-include "FCTTRE.h"
-!  ----------------------------------------
-
-        print *,'dtime, tau ',dtime,tau
-        print *, 't_targ',t_targ
-        print *, 'rh_targ',rh_targ
-        print *,'temp ',t
-        print *,'hum ',q
-
-        DO k = 1,klev
-         DO i = 1,klon
-           IF (paprs(i,1)-pplay(i,k) .GT. 10000.) THEN
-            IF (t(i,k).LT.RTT) THEN
-               zx_qs = qsats(t(i,k))/(pplay(i,k))
-            ELSE
-               zx_qs = qsatl(t(i,k))/(pplay(i,k))
-            ENDIF
-            rh = q(i,k)/zx_qs
-
-            d_t(i,k) = d_t(i,k) + 1./tau*(t_targ(i,k)-t(i,k))
-            d_rh = 1./tau*(rh_targ(i,k)-rh)
-
-            tnew = t(i,k)+d_t(i,k)*dtime
-!jyg<
-!   Formule pour q :
-!                         d_q = (1/tau) [rh_targ*qsat(T_new) - q] 
-
-!  Cette formule remplace d_q = (1/tau) [rh_targ - rh] qsat(T_new)
-!   qui n'etait pas correcte.
-
-            IF (tnew.LT.RTT) THEN
-               zx_qs = qsats(tnew)/(pplay(i,k))
-            ELSE
-               zx_qs = qsatl(tnew)/(pplay(i,k))
-            ENDIF
-!!            d_q(i,k) = d_q(i,k) + d_rh*zx_qs
-            d_q(i,k) = d_q(i,k) + (1./tau)*(rh_targ(i,k)*zx_qs - q(i,k))
-            rhnew = (q(i,k)+d_q(i,k)*dtime)/zx_qs
-
-            print *,' k,d_t,rh,d_rh,rhnew,d_q ',    &
-                      k,d_t(i,k),rh,d_rh,rhnew,d_q(i,k)
-           ENDIF
-
-         ENDDO
-        ENDDO
-
-      RETURN
-      END
-
-      Subroutine Nudge_UV (dtime,paprs,pplay,u_targ,v_targ,u,v,          &
-     &                      d_u,d_v)
-! ========================================================
+  ! ========================================================
+  REAL dtime
+  REAL paprs(klon, klevp1)
+  REAL pplay(klon, klev)
+
+  !      Variables d'etat
+  REAL t(klon, klev)
+  REAL q(klon, klev)
+
+  ! Tendances
+  REAL d_t(klon, klev)
+  REAL d_q(klon, klev)
+
+  !   Profiles cible
+  REAL t_targ(klon, klev)
+  REAL rh_targ(klon, klev)
+
+  !   Temps de relaxation
+  REAL tau
+  !c      DATA tau /3600./
+  !!      DATA tau /5400./
+  DATA tau /1800./
+
+  INTEGER k, i
+  REAL zx_qs, rh, tnew, d_rh, rhnew
+
+  ! Declaration des constantes et des fonctions thermodynamiques
+
+  include "YOMCST.h"
+  include "YOETHF.h"
+
+  !  ----------------------------------------
+  !  Statement functions
+  include "FCTTRE.h"
+  !  ----------------------------------------
+
+  print *, 'dtime, tau ', dtime, tau
+  print *, 't_targ', t_targ
+  print *, 'rh_targ', rh_targ
+  print *, 'temp ', t
+  print *, 'hum ', q
+
+  DO k = 1, klev
+    DO i = 1, klon
+      IF (paprs(i, 1) - pplay(i, k) > 10000.) THEN
+        IF (t(i, k)<RTT) THEN
+          zx_qs = qsats(t(i, k)) / (pplay(i, k))
+        ELSE
+          zx_qs = qsatl(t(i, k)) / (pplay(i, k))
+        ENDIF
+        rh = q(i, k) / zx_qs
+
+        d_t(i, k) = d_t(i, k) + 1. / tau * (t_targ(i, k) - t(i, k))
+        d_rh = 1. / tau * (rh_targ(i, k) - rh)
+
+        tnew = t(i, k) + d_t(i, k) * dtime
+        !jyg<
+        !   Formule pour q :
+        !                         d_q = (1/tau) [rh_targ*qsat(T_new) - q]
+
+        !  Cette formule remplace d_q = (1/tau) [rh_targ - rh] qsat(T_new)
+        !   qui n'etait pas correcte.
+
+        IF (tnew<RTT) THEN
+          zx_qs = qsats(tnew) / (pplay(i, k))
+        ELSE
+          zx_qs = qsatl(tnew) / (pplay(i, k))
+        ENDIF
+        !!            d_q(i,k) = d_q(i,k) + d_rh*zx_qs
+        d_q(i, k) = d_q(i, k) + (1. / tau) * (rh_targ(i, k) * zx_qs - q(i, k))
+        rhnew = (q(i, k) + d_q(i, k) * dtime) / zx_qs
+
+        print *, ' k,d_t,rh,d_rh,rhnew,d_q ', &
+                k, d_t(i, k), rh, d_rh, rhnew, d_q(i, k)
+      ENDIF
+
+    ENDDO
+  ENDDO
+
+  RETURN
+END
+
+Subroutine Nudge_UV (dtime, paprs, pplay, u_targ, v_targ, u, v, &
+        &                      d_u, d_v)
+  ! ========================================================
   USE dimphy
 
   implicit none
 
-! ========================================================
-      REAL dtime
-      REAL paprs(klon,klevp1)
-      REAL pplay(klon,klev)
-
-!      Variables d'etat
-      REAL u(klon,klev)
-      REAL v(klon,klev)
-
-! Tendances
-      REAL d_u(klon,klev)
-      REAL d_v(klon,klev)
-
-!   Profiles cible
-      REAL u_targ(klon,klev)
-      REAL v_targ(klon,klev)
-
-!   Temps de relaxation
-      REAL tau
-!c      DATA tau /3600./
-!      DATA tau /5400./
-       DATA tau /43200./
-
-   INTEGER k,i
-
-        !print *,'dtime, tau ',dtime,tau
-        !print *, 'u_targ',u_targ
-        !print *, 'v_targ',v_targ
-        !print *,'zonal velocity ',u
-        !print *,'meridional velocity ',v
-        DO k = 1,klev
-         DO i = 1,klon
-!CR: nudging everywhere
-!           IF (paprs(i,1)-pplay(i,k) .GT. 10000.) THEN
-
-            d_u(i,k) = d_u(i,k) + 1./tau*(u_targ(i,k)-u(i,k))
-            d_v(i,k) = d_v(i,k) + 1./tau*(v_targ(i,k)-v(i,k))
-
-!           print *,' k,u,d_u,v,d_v ',    &
-!                     k,u(i,k),d_u(i,k),v(i,k),d_v(i,k)
-!           ENDIF
-
-         ENDDO
-        ENDDO
-
-      RETURN
-      END
+  ! ========================================================
+  REAL dtime
+  REAL paprs(klon, klevp1)
+  REAL pplay(klon, klev)
+
+  !      Variables d'etat
+  REAL u(klon, klev)
+  REAL v(klon, klev)
+
+  ! Tendances
+  REAL d_u(klon, klev)
+  REAL d_v(klon, klev)
+
+  !   Profiles cible
+  REAL u_targ(klon, klev)
+  REAL v_targ(klon, klev)
+
+  !   Temps de relaxation
+  REAL tau
+  !c      DATA tau /3600./
+  !      DATA tau /5400./
+  DATA tau /43200./
+
+  INTEGER k, i
+
+  !print *,'dtime, tau ',dtime,tau
+  !print *, 'u_targ',u_targ
+  !print *, 'v_targ',v_targ
+  !print *,'zonal velocity ',u
+  !print *,'meridional velocity ',v
+  DO k = 1, klev
+    DO i = 1, klon
+      !CR: nudging everywhere
+      !           IF (paprs(i,1)-pplay(i,k) .GT. 10000.) THEN
+
+      d_u(i, k) = d_u(i, k) + 1. / tau * (u_targ(i, k) - u(i, k))
+      d_v(i, k) = d_v(i, k) + 1. / tau * (v_targ(i, k) - v(i, k))
+
+      !           print *,' k,u,d_u,v,d_v ',    &
+      !                     k,u(i,k),d_u(i,k),v(i,k),d_v(i,k)
+      !           ENDIF
+
+    ENDDO
+  ENDDO
+
+  RETURN
+END
 
 !=====================================================================
-       SUBROUTINE interp2_case_vertical(play,nlev_cas,plev_prof_cas                                    &
-     &         ,t_prof_cas,th_prof_cas,thv_prof_cas,thl_prof_cas                                       &
-     &         ,qv_prof_cas,ql_prof_cas,qi_prof_cas,u_prof_cas,v_prof_cas                              &
-     &         ,ug_prof_cas,vg_prof_cas,vitw_prof_cas,omega_prof_cas                                   &
-     &         ,du_prof_cas,hu_prof_cas,vu_prof_cas,dv_prof_cas,hv_prof_cas,vv_prof_cas                &
-     &         ,dt_prof_cas,ht_prof_cas,vt_prof_cas,dtrad_prof_cas,dq_prof_cas,hq_prof_cas,vq_prof_cas &
-     &         ,dth_prof_cas,hth_prof_cas,vth_prof_cas                                                 &
-
-     &         ,t_mod_cas,theta_mod_cas,thv_mod_cas,thl_mod_cas                                        &
-     &         ,qv_mod_cas,ql_mod_cas,qi_mod_cas,u_mod_cas,v_mod_cas                                   &
-     &         ,ug_mod_cas,vg_mod_cas,w_mod_cas,omega_mod_cas                                          &
-     &         ,du_mod_cas,hu_mod_cas,vu_mod_cas,dv_mod_cas,hv_mod_cas,vv_mod_cas                      &
-     &         ,dt_mod_cas,ht_mod_cas,vt_mod_cas,dtrad_mod_cas,dq_mod_cas,hq_mod_cas,vq_mod_cas        &
-     &         ,dth_mod_cas,hth_mod_cas,vth_mod_cas,mxcalc)
- 
-       implicit none
- 
-#include "YOMCST.h"
-#include "dimensions.h"
-
-!-------------------------------------------------------------------------
-! Vertical interpolation of generic case forcing data onto mod_casel levels
-!-------------------------------------------------------------------------
- 
-       integer nlevmax
-       parameter (nlevmax=41)
-       integer nlev_cas,mxcalc
-!       real play(llm), plev_prof(nlevmax) 
-!       real t_prof(nlevmax),q_prof(nlevmax)
-!       real u_prof(nlevmax),v_prof(nlevmax), w_prof(nlevmax)
-!       real ht_prof(nlevmax),vt_prof(nlevmax)
-!       real hq_prof(nlevmax),vq_prof(nlevmax)
- 
-       real play(llm), plev_prof_cas(nlev_cas) 
-       real t_prof_cas(nlev_cas),th_prof_cas(nlev_cas),thv_prof_cas(nlev_cas),thl_prof_cas(nlev_cas)
-       real qv_prof_cas(nlev_cas),ql_prof_cas(nlev_cas),qi_prof_cas(nlev_cas)
-       real u_prof_cas(nlev_cas),v_prof_cas(nlev_cas)
-       real ug_prof_cas(nlev_cas),vg_prof_cas(nlev_cas), vitw_prof_cas(nlev_cas),omega_prof_cas(nlev_cas)
-       real du_prof_cas(nlev_cas),hu_prof_cas(nlev_cas),vu_prof_cas(nlev_cas)
-       real dv_prof_cas(nlev_cas),hv_prof_cas(nlev_cas),vv_prof_cas(nlev_cas)
-       real dt_prof_cas(nlev_cas),ht_prof_cas(nlev_cas),vt_prof_cas(nlev_cas),dtrad_prof_cas(nlev_cas)
-       real dth_prof_cas(nlev_cas),hth_prof_cas(nlev_cas),vth_prof_cas(nlev_cas)
-       real dq_prof_cas(nlev_cas),hq_prof_cas(nlev_cas),vq_prof_cas(nlev_cas)
- 
-       real t_mod_cas(llm),theta_mod_cas(llm),thv_mod_cas(llm),thl_mod_cas(llm)
-       real qv_mod_cas(llm),ql_mod_cas(llm),qi_mod_cas(llm)
-       real u_mod_cas(llm),v_mod_cas(llm)
-       real ug_mod_cas(llm),vg_mod_cas(llm), w_mod_cas(llm),omega_mod_cas(llm)
-       real du_mod_cas(llm),hu_mod_cas(llm),vu_mod_cas(llm)
-       real dv_mod_cas(llm),hv_mod_cas(llm),vv_mod_cas(llm)
-       real dt_mod_cas(llm),ht_mod_cas(llm),vt_mod_cas(llm),dtrad_mod_cas(llm)
-       real dth_mod_cas(llm),hth_mod_cas(llm),vth_mod_cas(llm)
-       real dq_mod_cas(llm),hq_mod_cas(llm),vq_mod_cas(llm)
- 
-       integer l,k,k1,k2
-       real frac,frac1,frac2,fact
- 
-!       do l = 1, llm
-!       print *,'debut interp2, play=',l,play(l)
-!       enddo
-!      do l = 1, nlev_cas
-!      print *,'debut interp2, plev_prof_cas=',l,play(l),plev_prof_cas(l)
-!      enddo
-
-       do l = 1, llm
-
-        if (play(l).ge.plev_prof_cas(nlev_cas)) then
- 
-        mxcalc=l
-!        print *,'debut interp2, mxcalc=',mxcalc
-         k1=0
-         k2=0
-
-         if (play(l).le.plev_prof_cas(1)) then
-
-         do k = 1, nlev_cas-1
-          if (play(l).le.plev_prof_cas(k).and. play(l).gt.plev_prof_cas(k+1)) then
-            k1=k
-            k2=k+1
+SUBROUTINE interp2_case_vertical(play, nlev_cas, plev_prof_cas                                    &
+        &, t_prof_cas, th_prof_cas, thv_prof_cas, thl_prof_cas                                       &
+        &, qv_prof_cas, ql_prof_cas, qi_prof_cas, u_prof_cas, v_prof_cas                              &
+        &, ug_prof_cas, vg_prof_cas, vitw_prof_cas, omega_prof_cas                                   &
+        &, du_prof_cas, hu_prof_cas, vu_prof_cas, dv_prof_cas, hv_prof_cas, vv_prof_cas                &
+        &, dt_prof_cas, ht_prof_cas, vt_prof_cas, dtrad_prof_cas, dq_prof_cas, hq_prof_cas, vq_prof_cas &
+        &, dth_prof_cas, hth_prof_cas, vth_prof_cas                                                 &
+
+        &, t_mod_cas, theta_mod_cas, thv_mod_cas, thl_mod_cas                                        &
+        &, qv_mod_cas, ql_mod_cas, qi_mod_cas, u_mod_cas, v_mod_cas                                   &
+        &, ug_mod_cas, vg_mod_cas, w_mod_cas, omega_mod_cas                                          &
+        &, du_mod_cas, hu_mod_cas, vu_mod_cas, dv_mod_cas, hv_mod_cas, vv_mod_cas                      &
+        &, dt_mod_cas, ht_mod_cas, vt_mod_cas, dtrad_mod_cas, dq_mod_cas, hq_mod_cas, vq_mod_cas        &
+        &, dth_mod_cas, hth_mod_cas, vth_mod_cas, mxcalc)
+
+  implicit none
+
+  include "YOMCST.h"
+  include "dimensions.h"
+
+  !-------------------------------------------------------------------------
+  ! Vertical interpolation of generic case forcing data onto mod_casel levels
+  !-------------------------------------------------------------------------
+
+  integer nlevmax
+  parameter (nlevmax = 41)
+  integer nlev_cas, mxcalc
+  !       real play(llm), plev_prof(nlevmax)
+  !       real t_prof(nlevmax),q_prof(nlevmax)
+  !       real u_prof(nlevmax),v_prof(nlevmax), w_prof(nlevmax)
+  !       real ht_prof(nlevmax),vt_prof(nlevmax)
+  !       real hq_prof(nlevmax),vq_prof(nlevmax)
+
+  real play(llm), plev_prof_cas(nlev_cas)
+  real t_prof_cas(nlev_cas), th_prof_cas(nlev_cas), thv_prof_cas(nlev_cas), thl_prof_cas(nlev_cas)
+  real qv_prof_cas(nlev_cas), ql_prof_cas(nlev_cas), qi_prof_cas(nlev_cas)
+  real u_prof_cas(nlev_cas), v_prof_cas(nlev_cas)
+  real ug_prof_cas(nlev_cas), vg_prof_cas(nlev_cas), vitw_prof_cas(nlev_cas), omega_prof_cas(nlev_cas)
+  real du_prof_cas(nlev_cas), hu_prof_cas(nlev_cas), vu_prof_cas(nlev_cas)
+  real dv_prof_cas(nlev_cas), hv_prof_cas(nlev_cas), vv_prof_cas(nlev_cas)
+  real dt_prof_cas(nlev_cas), ht_prof_cas(nlev_cas), vt_prof_cas(nlev_cas), dtrad_prof_cas(nlev_cas)
+  real dth_prof_cas(nlev_cas), hth_prof_cas(nlev_cas), vth_prof_cas(nlev_cas)
+  real dq_prof_cas(nlev_cas), hq_prof_cas(nlev_cas), vq_prof_cas(nlev_cas)
+
+  real t_mod_cas(llm), theta_mod_cas(llm), thv_mod_cas(llm), thl_mod_cas(llm)
+  real qv_mod_cas(llm), ql_mod_cas(llm), qi_mod_cas(llm)
+  real u_mod_cas(llm), v_mod_cas(llm)
+  real ug_mod_cas(llm), vg_mod_cas(llm), w_mod_cas(llm), omega_mod_cas(llm)
+  real du_mod_cas(llm), hu_mod_cas(llm), vu_mod_cas(llm)
+  real dv_mod_cas(llm), hv_mod_cas(llm), vv_mod_cas(llm)
+  real dt_mod_cas(llm), ht_mod_cas(llm), vt_mod_cas(llm), dtrad_mod_cas(llm)
+  real dth_mod_cas(llm), hth_mod_cas(llm), vth_mod_cas(llm)
+  real dq_mod_cas(llm), hq_mod_cas(llm), vq_mod_cas(llm)
+
+  integer l, k, k1, k2
+  real frac, frac1, frac2, fact
+
+  !       do l = 1, llm
+  !       print *,'debut interp2, play=',l,play(l)
+  !       enddo
+  !      do l = 1, nlev_cas
+  !      print *,'debut interp2, plev_prof_cas=',l,play(l),plev_prof_cas(l)
+  !      enddo
+
+  do l = 1, llm
+
+    if (play(l)>=plev_prof_cas(nlev_cas)) then
+
+      mxcalc = l
+      !        print *,'debut interp2, mxcalc=',mxcalc
+      k1 = 0
+      k2 = 0
+
+      if (play(l)<=plev_prof_cas(1)) then
+
+        do k = 1, nlev_cas - 1
+          if (play(l)<=plev_prof_cas(k).and. play(l)>plev_prof_cas(k + 1)) then
+            k1 = k
+            k2 = k + 1
           endif
-         enddo
-
-         if (k1.eq.0 .or. k2.eq.0) then
-          write(*,*) 'PB! k1, k2 = ',k1,k2
-          write(*,*) 'l,play(l) = ',l,play(l)/100
-         do k = 1, nlev_cas-1
-          write(*,*) 'k,plev_prof_cas(k) = ',k,plev_prof_cas(k)/100
-         enddo
-         endif
-
-         frac = (plev_prof_cas(k2)-play(l))/(plev_prof_cas(k2)-plev_prof_cas(k1))
-         t_mod_cas(l)= t_prof_cas(k2) - frac*(t_prof_cas(k2)-t_prof_cas(k1))
-         theta_mod_cas(l)= th_prof_cas(k2) - frac*(th_prof_cas(k2)-th_prof_cas(k1))
-         if(theta_mod_cas(l).NE.0) t_mod_cas(l)= theta_mod_cas(l)*(play(l)/100000.)**(RD/RCPD)
-         thv_mod_cas(l)= thv_prof_cas(k2) - frac*(thv_prof_cas(k2)-thv_prof_cas(k1))
-         thl_mod_cas(l)= thl_prof_cas(k2) - frac*(thl_prof_cas(k2)-thl_prof_cas(k1))
-         qv_mod_cas(l)= qv_prof_cas(k2) - frac*(qv_prof_cas(k2)-qv_prof_cas(k1))
-         ql_mod_cas(l)= ql_prof_cas(k2) - frac*(ql_prof_cas(k2)-ql_prof_cas(k1))
-         qi_mod_cas(l)= qi_prof_cas(k2) - frac*(qi_prof_cas(k2)-qi_prof_cas(k1))
-         u_mod_cas(l)= u_prof_cas(k2) - frac*(u_prof_cas(k2)-u_prof_cas(k1))
-         v_mod_cas(l)= v_prof_cas(k2) - frac*(v_prof_cas(k2)-v_prof_cas(k1))
-         ug_mod_cas(l)= ug_prof_cas(k2) - frac*(ug_prof_cas(k2)-ug_prof_cas(k1))
-         vg_mod_cas(l)= vg_prof_cas(k2) - frac*(vg_prof_cas(k2)-vg_prof_cas(k1))
-         w_mod_cas(l)= vitw_prof_cas(k2) - frac*(vitw_prof_cas(k2)-vitw_prof_cas(k1))
-         omega_mod_cas(l)= omega_prof_cas(k2) - frac*(omega_prof_cas(k2)-omega_prof_cas(k1))
-         du_mod_cas(l)= du_prof_cas(k2) - frac*(du_prof_cas(k2)-du_prof_cas(k1))
-         hu_mod_cas(l)= hu_prof_cas(k2) - frac*(hu_prof_cas(k2)-hu_prof_cas(k1))
-         vu_mod_cas(l)= vu_prof_cas(k2) - frac*(vu_prof_cas(k2)-vu_prof_cas(k1))
-         dv_mod_cas(l)= dv_prof_cas(k2) - frac*(dv_prof_cas(k2)-dv_prof_cas(k1))
-         hv_mod_cas(l)= hv_prof_cas(k2) - frac*(hv_prof_cas(k2)-hv_prof_cas(k1))
-         vv_mod_cas(l)= vv_prof_cas(k2) - frac*(vv_prof_cas(k2)-vv_prof_cas(k1))
-         dt_mod_cas(l)= dt_prof_cas(k2) - frac*(dt_prof_cas(k2)-dt_prof_cas(k1))
-         ht_mod_cas(l)= ht_prof_cas(k2) - frac*(ht_prof_cas(k2)-ht_prof_cas(k1))
-         vt_mod_cas(l)= vt_prof_cas(k2) - frac*(vt_prof_cas(k2)-vt_prof_cas(k1))
-         dth_mod_cas(l)= dth_prof_cas(k2) - frac*(dth_prof_cas(k2)-dth_prof_cas(k1))
-         hth_mod_cas(l)= hth_prof_cas(k2) - frac*(hth_prof_cas(k2)-hth_prof_cas(k1))
-         vth_mod_cas(l)= vth_prof_cas(k2) - frac*(vth_prof_cas(k2)-vth_prof_cas(k1))
-         dq_mod_cas(l)= dq_prof_cas(k2) - frac*(dq_prof_cas(k2)-dq_prof_cas(k1))
-         hq_mod_cas(l)= hq_prof_cas(k2) - frac*(hq_prof_cas(k2)-hq_prof_cas(k1))
-         vq_mod_cas(l)= vq_prof_cas(k2) - frac*(vq_prof_cas(k2)-vq_prof_cas(k1))
-         dtrad_mod_cas(l)= dtrad_prof_cas(k2) - frac*(dtrad_prof_cas(k2)-dtrad_prof_cas(k1))
-     
-         else !play>plev_prof_cas(1)
-
-         k1=1
-         k2=2
-         print *,'interp2_vert, k1,k2=',plev_prof_cas(k1),plev_prof_cas(k2)
-         frac1 = (play(l)-plev_prof_cas(k2))/(plev_prof_cas(k1)-plev_prof_cas(k2))
-         frac2 = (play(l)-plev_prof_cas(k1))/(plev_prof_cas(k1)-plev_prof_cas(k2))
-         t_mod_cas(l)= frac1*t_prof_cas(k1) - frac2*t_prof_cas(k2)
-         theta_mod_cas(l)= frac1*th_prof_cas(k1) - frac2*th_prof_cas(k2)
-         if(theta_mod_cas(l).NE.0) t_mod_cas(l)= theta_mod_cas(l)*(play(l)/100000.)**(RD/RCPD)
-         thv_mod_cas(l)= frac1*thv_prof_cas(k1) - frac2*thv_prof_cas(k2)
-         thl_mod_cas(l)= frac1*thl_prof_cas(k1) - frac2*thl_prof_cas(k2)
-         qv_mod_cas(l)= frac1*qv_prof_cas(k1) - frac2*qv_prof_cas(k2)
-         ql_mod_cas(l)= frac1*ql_prof_cas(k1) - frac2*ql_prof_cas(k2)
-         qi_mod_cas(l)= frac1*qi_prof_cas(k1) - frac2*qi_prof_cas(k2)
-         u_mod_cas(l)= frac1*u_prof_cas(k1) - frac2*u_prof_cas(k2)
-         v_mod_cas(l)= frac1*v_prof_cas(k1) - frac2*v_prof_cas(k2)
-         ug_mod_cas(l)= frac1*ug_prof_cas(k1) - frac2*ug_prof_cas(k2)
-         vg_mod_cas(l)= frac1*vg_prof_cas(k1) - frac2*vg_prof_cas(k2)
-         w_mod_cas(l)= frac1*vitw_prof_cas(k1) - frac2*vitw_prof_cas(k2)
-         omega_mod_cas(l)= frac1*omega_prof_cas(k1) - frac2*omega_prof_cas(k2)
-         du_mod_cas(l)= frac1*du_prof_cas(k1) - frac2*du_prof_cas(k2)
-         hu_mod_cas(l)= frac1*hu_prof_cas(k1) - frac2*hu_prof_cas(k2)
-         vu_mod_cas(l)= frac1*vu_prof_cas(k1) - frac2*vu_prof_cas(k2)
-         dv_mod_cas(l)= frac1*dv_prof_cas(k1) - frac2*dv_prof_cas(k2)
-         hv_mod_cas(l)= frac1*hv_prof_cas(k1) - frac2*hv_prof_cas(k2)
-         vv_mod_cas(l)= frac1*vv_prof_cas(k1) - frac2*vv_prof_cas(k2)
-         dt_mod_cas(l)= frac1*dt_prof_cas(k1) - frac2*dt_prof_cas(k2)
-         ht_mod_cas(l)= frac1*ht_prof_cas(k1) - frac2*ht_prof_cas(k2)
-         vt_mod_cas(l)= frac1*vt_prof_cas(k1) - frac2*vt_prof_cas(k2)
-         dth_mod_cas(l)= frac1*dth_prof_cas(k1) - frac2*dth_prof_cas(k2)
-         hth_mod_cas(l)= frac1*hth_prof_cas(k1) - frac2*hth_prof_cas(k2)
-         vth_mod_cas(l)= frac1*vth_prof_cas(k1) - frac2*vth_prof_cas(k2)
-         dq_mod_cas(l)= frac1*dq_prof_cas(k1) - frac2*dq_prof_cas(k2)
-         hq_mod_cas(l)= frac1*hq_prof_cas(k1) - frac2*hq_prof_cas(k2)
-         vq_mod_cas(l)= frac1*vq_prof_cas(k1) - frac2*vq_prof_cas(k2)
-         dtrad_mod_cas(l)= frac1*dtrad_prof_cas(k1) - frac2*dtrad_prof_cas(k2)
-
-         endif ! play.le.plev_prof_cas(1)
-
-        else ! above max altitude of forcing file
- 
-!jyg
-         fact=20.*(plev_prof_cas(nlev_cas)-play(l))/plev_prof_cas(nlev_cas) !jyg
-         fact = max(fact,0.)                                           !jyg
-         fact = exp(-fact)                                             !jyg
-         t_mod_cas(l)= t_prof_cas(nlev_cas)                            !jyg
-         theta_mod_cas(l)= th_prof_cas(nlev_cas)                       !jyg
-         thv_mod_cas(l)= thv_prof_cas(nlev_cas)                        !jyg
-         thl_mod_cas(l)= thl_prof_cas(nlev_cas)                        !jyg
-         qv_mod_cas(l)= qv_prof_cas(nlev_cas)*fact                     !jyg
-         ql_mod_cas(l)= ql_prof_cas(nlev_cas)*fact                     !jyg
-         qi_mod_cas(l)= qi_prof_cas(nlev_cas)*fact                     !jyg
-         u_mod_cas(l)= u_prof_cas(nlev_cas)*fact                       !jyg
-         v_mod_cas(l)= v_prof_cas(nlev_cas)*fact                       !jyg
-         ug_mod_cas(l)= ug_prof_cas(nlev_cas)*fact                     !jyg
-         vg_mod_cas(l)= vg_prof_cas(nlev_cas)*fact                     !jyg
-         w_mod_cas(l)= 0.0                                             !jyg
-         omega_mod_cas(l)= 0.0                                         !jyg
-         du_mod_cas(l)= du_prof_cas(nlev_cas)*fact 
-         hu_mod_cas(l)= hu_prof_cas(nlev_cas)*fact                     !jyg
-         vu_mod_cas(l)= vu_prof_cas(nlev_cas)*fact                     !jyg
-         dv_mod_cas(l)= dv_prof_cas(nlev_cas)*fact
-         hv_mod_cas(l)= hv_prof_cas(nlev_cas)*fact                     !jyg
-         vv_mod_cas(l)= vv_prof_cas(nlev_cas)*fact                     !jyg
-         dt_mod_cas(l)= dt_prof_cas(nlev_cas) 
-         ht_mod_cas(l)= ht_prof_cas(nlev_cas)                          !jyg
-         vt_mod_cas(l)= vt_prof_cas(nlev_cas)                          !jyg
-         dth_mod_cas(l)= dth_prof_cas(nlev_cas) 
-         hth_mod_cas(l)= hth_prof_cas(nlev_cas)                        !jyg
-         vth_mod_cas(l)= vth_prof_cas(nlev_cas)                        !jyg
-         dq_mod_cas(l)= dq_prof_cas(nlev_cas)*fact 
-         hq_mod_cas(l)= hq_prof_cas(nlev_cas)*fact                     !jyg
-         vq_mod_cas(l)= vq_prof_cas(nlev_cas)*fact                     !jyg
-         dtrad_mod_cas(l)= dtrad_prof_cas(nlev_cas)*fact               !jyg
- 
-        endif ! play
- 
-       enddo ! l
-
-          return
-          end
+        enddo
+
+        if (k1==0 .or. k2==0) then
+          write(*, *) 'PB! k1, k2 = ', k1, k2
+          write(*, *) 'l,play(l) = ', l, play(l) / 100
+          do k = 1, nlev_cas - 1
+            write(*, *) 'k,plev_prof_cas(k) = ', k, plev_prof_cas(k) / 100
+          enddo
+        endif
+
+        frac = (plev_prof_cas(k2) - play(l)) / (plev_prof_cas(k2) - plev_prof_cas(k1))
+        t_mod_cas(l) = t_prof_cas(k2) - frac * (t_prof_cas(k2) - t_prof_cas(k1))
+        theta_mod_cas(l) = th_prof_cas(k2) - frac * (th_prof_cas(k2) - th_prof_cas(k1))
+        if(theta_mod_cas(l)/=0) t_mod_cas(l) = theta_mod_cas(l) * (play(l) / 100000.)**(RD / RCPD)
+        thv_mod_cas(l) = thv_prof_cas(k2) - frac * (thv_prof_cas(k2) - thv_prof_cas(k1))
+        thl_mod_cas(l) = thl_prof_cas(k2) - frac * (thl_prof_cas(k2) - thl_prof_cas(k1))
+        qv_mod_cas(l) = qv_prof_cas(k2) - frac * (qv_prof_cas(k2) - qv_prof_cas(k1))
+        ql_mod_cas(l) = ql_prof_cas(k2) - frac * (ql_prof_cas(k2) - ql_prof_cas(k1))
+        qi_mod_cas(l) = qi_prof_cas(k2) - frac * (qi_prof_cas(k2) - qi_prof_cas(k1))
+        u_mod_cas(l) = u_prof_cas(k2) - frac * (u_prof_cas(k2) - u_prof_cas(k1))
+        v_mod_cas(l) = v_prof_cas(k2) - frac * (v_prof_cas(k2) - v_prof_cas(k1))
+        ug_mod_cas(l) = ug_prof_cas(k2) - frac * (ug_prof_cas(k2) - ug_prof_cas(k1))
+        vg_mod_cas(l) = vg_prof_cas(k2) - frac * (vg_prof_cas(k2) - vg_prof_cas(k1))
+        w_mod_cas(l) = vitw_prof_cas(k2) - frac * (vitw_prof_cas(k2) - vitw_prof_cas(k1))
+        omega_mod_cas(l) = omega_prof_cas(k2) - frac * (omega_prof_cas(k2) - omega_prof_cas(k1))
+        du_mod_cas(l) = du_prof_cas(k2) - frac * (du_prof_cas(k2) - du_prof_cas(k1))
+        hu_mod_cas(l) = hu_prof_cas(k2) - frac * (hu_prof_cas(k2) - hu_prof_cas(k1))
+        vu_mod_cas(l) = vu_prof_cas(k2) - frac * (vu_prof_cas(k2) - vu_prof_cas(k1))
+        dv_mod_cas(l) = dv_prof_cas(k2) - frac * (dv_prof_cas(k2) - dv_prof_cas(k1))
+        hv_mod_cas(l) = hv_prof_cas(k2) - frac * (hv_prof_cas(k2) - hv_prof_cas(k1))
+        vv_mod_cas(l) = vv_prof_cas(k2) - frac * (vv_prof_cas(k2) - vv_prof_cas(k1))
+        dt_mod_cas(l) = dt_prof_cas(k2) - frac * (dt_prof_cas(k2) - dt_prof_cas(k1))
+        ht_mod_cas(l) = ht_prof_cas(k2) - frac * (ht_prof_cas(k2) - ht_prof_cas(k1))
+        vt_mod_cas(l) = vt_prof_cas(k2) - frac * (vt_prof_cas(k2) - vt_prof_cas(k1))
+        dth_mod_cas(l) = dth_prof_cas(k2) - frac * (dth_prof_cas(k2) - dth_prof_cas(k1))
+        hth_mod_cas(l) = hth_prof_cas(k2) - frac * (hth_prof_cas(k2) - hth_prof_cas(k1))
+        vth_mod_cas(l) = vth_prof_cas(k2) - frac * (vth_prof_cas(k2) - vth_prof_cas(k1))
+        dq_mod_cas(l) = dq_prof_cas(k2) - frac * (dq_prof_cas(k2) - dq_prof_cas(k1))
+        hq_mod_cas(l) = hq_prof_cas(k2) - frac * (hq_prof_cas(k2) - hq_prof_cas(k1))
+        vq_mod_cas(l) = vq_prof_cas(k2) - frac * (vq_prof_cas(k2) - vq_prof_cas(k1))
+        dtrad_mod_cas(l) = dtrad_prof_cas(k2) - frac * (dtrad_prof_cas(k2) - dtrad_prof_cas(k1))
+
+      else !play>plev_prof_cas(1)
+
+        k1 = 1
+        k2 = 2
+        print *, 'interp2_vert, k1,k2=', plev_prof_cas(k1), plev_prof_cas(k2)
+        frac1 = (play(l) - plev_prof_cas(k2)) / (plev_prof_cas(k1) - plev_prof_cas(k2))
+        frac2 = (play(l) - plev_prof_cas(k1)) / (plev_prof_cas(k1) - plev_prof_cas(k2))
+        t_mod_cas(l) = frac1 * t_prof_cas(k1) - frac2 * t_prof_cas(k2)
+        theta_mod_cas(l) = frac1 * th_prof_cas(k1) - frac2 * th_prof_cas(k2)
+        if(theta_mod_cas(l)/=0) t_mod_cas(l) = theta_mod_cas(l) * (play(l) / 100000.)**(RD / RCPD)
+        thv_mod_cas(l) = frac1 * thv_prof_cas(k1) - frac2 * thv_prof_cas(k2)
+        thl_mod_cas(l) = frac1 * thl_prof_cas(k1) - frac2 * thl_prof_cas(k2)
+        qv_mod_cas(l) = frac1 * qv_prof_cas(k1) - frac2 * qv_prof_cas(k2)
+        ql_mod_cas(l) = frac1 * ql_prof_cas(k1) - frac2 * ql_prof_cas(k2)
+        qi_mod_cas(l) = frac1 * qi_prof_cas(k1) - frac2 * qi_prof_cas(k2)
+        u_mod_cas(l) = frac1 * u_prof_cas(k1) - frac2 * u_prof_cas(k2)
+        v_mod_cas(l) = frac1 * v_prof_cas(k1) - frac2 * v_prof_cas(k2)
+        ug_mod_cas(l) = frac1 * ug_prof_cas(k1) - frac2 * ug_prof_cas(k2)
+        vg_mod_cas(l) = frac1 * vg_prof_cas(k1) - frac2 * vg_prof_cas(k2)
+        w_mod_cas(l) = frac1 * vitw_prof_cas(k1) - frac2 * vitw_prof_cas(k2)
+        omega_mod_cas(l) = frac1 * omega_prof_cas(k1) - frac2 * omega_prof_cas(k2)
+        du_mod_cas(l) = frac1 * du_prof_cas(k1) - frac2 * du_prof_cas(k2)
+        hu_mod_cas(l) = frac1 * hu_prof_cas(k1) - frac2 * hu_prof_cas(k2)
+        vu_mod_cas(l) = frac1 * vu_prof_cas(k1) - frac2 * vu_prof_cas(k2)
+        dv_mod_cas(l) = frac1 * dv_prof_cas(k1) - frac2 * dv_prof_cas(k2)
+        hv_mod_cas(l) = frac1 * hv_prof_cas(k1) - frac2 * hv_prof_cas(k2)
+        vv_mod_cas(l) = frac1 * vv_prof_cas(k1) - frac2 * vv_prof_cas(k2)
+        dt_mod_cas(l) = frac1 * dt_prof_cas(k1) - frac2 * dt_prof_cas(k2)
+        ht_mod_cas(l) = frac1 * ht_prof_cas(k1) - frac2 * ht_prof_cas(k2)
+        vt_mod_cas(l) = frac1 * vt_prof_cas(k1) - frac2 * vt_prof_cas(k2)
+        dth_mod_cas(l) = frac1 * dth_prof_cas(k1) - frac2 * dth_prof_cas(k2)
+        hth_mod_cas(l) = frac1 * hth_prof_cas(k1) - frac2 * hth_prof_cas(k2)
+        vth_mod_cas(l) = frac1 * vth_prof_cas(k1) - frac2 * vth_prof_cas(k2)
+        dq_mod_cas(l) = frac1 * dq_prof_cas(k1) - frac2 * dq_prof_cas(k2)
+        hq_mod_cas(l) = frac1 * hq_prof_cas(k1) - frac2 * hq_prof_cas(k2)
+        vq_mod_cas(l) = frac1 * vq_prof_cas(k1) - frac2 * vq_prof_cas(k2)
+        dtrad_mod_cas(l) = frac1 * dtrad_prof_cas(k1) - frac2 * dtrad_prof_cas(k2)
+
+      endif ! play.le.plev_prof_cas(1)
+
+    else ! above max altitude of forcing file
+
+      !jyg
+      fact = 20. * (plev_prof_cas(nlev_cas) - play(l)) / plev_prof_cas(nlev_cas) !jyg
+      fact = max(fact, 0.)                                           !jyg
+      fact = exp(-fact)                                             !jyg
+      t_mod_cas(l) = t_prof_cas(nlev_cas)                            !jyg
+      theta_mod_cas(l) = th_prof_cas(nlev_cas)                       !jyg
+      thv_mod_cas(l) = thv_prof_cas(nlev_cas)                        !jyg
+      thl_mod_cas(l) = thl_prof_cas(nlev_cas)                        !jyg
+      qv_mod_cas(l) = qv_prof_cas(nlev_cas) * fact                     !jyg
+      ql_mod_cas(l) = ql_prof_cas(nlev_cas) * fact                     !jyg
+      qi_mod_cas(l) = qi_prof_cas(nlev_cas) * fact                     !jyg
+      u_mod_cas(l) = u_prof_cas(nlev_cas) * fact                       !jyg
+      v_mod_cas(l) = v_prof_cas(nlev_cas) * fact                       !jyg
+      ug_mod_cas(l) = ug_prof_cas(nlev_cas) * fact                     !jyg
+      vg_mod_cas(l) = vg_prof_cas(nlev_cas) * fact                     !jyg
+      w_mod_cas(l) = 0.0                                             !jyg
+      omega_mod_cas(l) = 0.0                                         !jyg
+      du_mod_cas(l) = du_prof_cas(nlev_cas) * fact
+      hu_mod_cas(l) = hu_prof_cas(nlev_cas) * fact                     !jyg
+      vu_mod_cas(l) = vu_prof_cas(nlev_cas) * fact                     !jyg
+      dv_mod_cas(l) = dv_prof_cas(nlev_cas) * fact
+      hv_mod_cas(l) = hv_prof_cas(nlev_cas) * fact                     !jyg
+      vv_mod_cas(l) = vv_prof_cas(nlev_cas) * fact                     !jyg
+      dt_mod_cas(l) = dt_prof_cas(nlev_cas)
+      ht_mod_cas(l) = ht_prof_cas(nlev_cas)                          !jyg
+      vt_mod_cas(l) = vt_prof_cas(nlev_cas)                          !jyg
+      dth_mod_cas(l) = dth_prof_cas(nlev_cas)
+      hth_mod_cas(l) = hth_prof_cas(nlev_cas)                        !jyg
+      vth_mod_cas(l) = vth_prof_cas(nlev_cas)                        !jyg
+      dq_mod_cas(l) = dq_prof_cas(nlev_cas) * fact
+      hq_mod_cas(l) = hq_prof_cas(nlev_cas) * fact                     !jyg
+      vq_mod_cas(l) = vq_prof_cas(nlev_cas) * fact                     !jyg
+      dtrad_mod_cas(l) = dtrad_prof_cas(nlev_cas) * fact               !jyg
+
+    endif ! play
+
+  enddo ! l
+
+  return
+end
 !***************************************************************************** 
 
